package com.example.stimulusStrategy;

import android.app.AlarmManager;
import android.app.PendingIntent;
import android.app.Service;
import android.app.job.JobInfo;
import android.app.job.JobScheduler;
import android.app.job.JobWorkItem;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.hardware.Sensor;
import android.hardware.SensorManager;
import android.hardware.TriggerEvent;
import android.hardware.TriggerEventListener;
import android.os.IBinder;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.util.Log;
import android.widget.Toast;

import com.example.notification.Notification;
import com.example.pharmacy.frontEnd.R;

import java.util.List;

/**
 * Created by pharmacy on 17/01/2018.
 */

public class SigMotionDetect extends Service implements StimulusStrategy {

    private SensorManager mSensorManager;
    private Sensor md;
    private TriggerEventListener tel;
    private AlarmManager am;


    //Set up alarm manager to fire in one hour, and set up significant motion sensor to fire and call monitor which
    // will then cancel the alarm and reschedule it for one hour from now. Monitor should also use step-counter? to monitor the length
    // of unsedentary behaviour for progress monitoring.
    @Override
    public void onCreate(){
        am = (AlarmManager) this.getSystemService(Context.ALARM_SERVICE);
        setUpClock();
        mSensorManager = (SensorManager) this.getSystemService(Context.SENSOR_SERVICE);
        //Need to test if this produces null to avoid NULLPOINTEREXCEPTION
            md = mSensorManager.getDefaultSensor(Sensor.TYPE_SIGNIFICANT_MOTION);

        tel = new TriggerEventListener() {
            @Override
            public void onTrigger(TriggerEvent triggerEvent) {
                monitor();
            }
        };
    }

    private void setUpClock() {
        Intent i = new Intent(this, Notification.class);
        PendingIntent pi = PendingIntent.getBroadcast(this, 0, i, 0);
        am.set(AlarmManager.ELAPSED_REALTIME, AlarmManager.INTERVAL_HOUR, pi);
       // Log.i("myTag", "Alarm SET");
    }

    public void monitor() {
        //Use step counter sensor? to detect if movement lasted for a prolonged period of time.
        //Anything over 60 steps per minute counts as a minute of activity.
        //Check every minute until the change is less than this.
        //Then register to daily progress for number of minutes > 60.
        Log.d("MOTION", "HUZZAH");
        am.cancel(am.getNextAlarmClock().getShowIntent());
        stepCounter();
        setUpClock();
        mSensorManager.requestTriggerSensor(tel, md);
    }

    private void stepCounter(){
        Sensor sc = mSensorManager.getDefaultSensor(Sensor.TYPE_STEP_COUNTER);
        //Use job scheduler to check once every minute while change > 60.
        JobScheduler jobs = (JobScheduler) this.getSystemService(Context.JOB_SCHEDULER_SERVICE);
        JobInfo.Builder builder = new JobInfo.Builder(R.integer.step_job ,new ComponentName(this, this.getClass()));
        //
       // builder.setPeriodic();
       // jobs.schedule();

    }

    @Nullable
    @Override
    public IBinder onBind(Intent intent) {
        return null;
    }
}
